UNIT KDSetBox;
{+H
---------------------------------------------------------------------------
  File        - KDSETBOX.PAS
  Purpose     - Registers KSS_DataSet components in Data Access.
  Copyright    1998 Keith S. Brown
  Author      - Keith S. Brown
  Reference   - source by Borland Int, etc.
  Revised     - 1998.1028 (KSB) Wrote first version.
---------------------------------------------------------------------------}
INTERFACE

{}PROCEDURE Register;
              {=================================================}
IMPLEMENTATION
USES
  DsgnIntf, EditIntf, ExptIntf, ToolIntf, Classes,  Controls, Forms,
  Dialogs,  SysUtils, KSSStore, KDataSet, KDS_Edit, Windows;

TYPE
  TKSS_AboutProperty = CLASS(TPropertyEditor)
  PRIVATE
    PROCEDURE   Edit; OVERRIDE;
    FUNCTION    GetAttributes: TPropertyAttributes; OVERRIDE;
    FUNCTION    GetValue: STRING; OVERRIDE;
  END {CLASS};


  TKSS_ColumnProperty = CLASS(TPropertyEditor)
    PROCEDURE   Edit; OVERRIDE;
    FUNCTION    GetAttributes:TPropertyAttributes; OVERRIDE;
    FUNCTION    GetValue:STRING; OVERRIDE;
  END {CLASS};


              {TKSS_AboutProperty }


{}PROCEDURE   TKSS_AboutProperty.Edit;
{+O
---------------------------------------------------------------------------
  Purpose     - Display the about dialog.
---------------------------------------------------------------------------}
  BEGIN
    Application.MessageBox(PChar(KDataSet.GetCopyright),PChar(KDataSet.GetVersion),MB_OK+ MB_ICONINFORMATION);
{}END {Edit};




{}FUNCTION    TKSS_AboutProperty.GetAttributes: TPropertyAttributes;
{+O
---------------------------------------------------------------------------
  Purpose     - The about property is a dialog & is read-only.
---------------------------------------------------------------------------}
  BEGIN
    GetAttributes:=[paDialog, paReadOnly];
{}END {GetAttributes};




{}FUNCTION    TKSS_AboutProperty.GetValue: STRING;
{+O
---------------------------------------------------------------------------
  Purpose     - The value to be displayed in the object inspector.
---------------------------------------------------------------------------}
  BEGIN
    GetValue:='(About)';
{}END {GetValue};


              {TKSS_ColumnProperty }


{}PROCEDURE   TKSS_ColumnProperty.Edit;
{+O
---------------------------------------------------------------------------
  Purpose     - Display the dialog box.
---------------------------------------------------------------------------}
  VAR
    loInfo    : TColumnDefs;
    ls        : STRING;
  BEGIN
    loInfo := TColumnDefs(GetOrdValue);
    ls := TComponent(GetComponent(0)).Owner.Name+'.'+TComponent(GetComponent(0)).Name+'.'+GetName+' - ';
    IF EditHeaderInfo(loInfo,ls) THEN BEGIN
      SetOrdValue(LongINT(loInfo));
    END {IF};
{}END {Edit};




{}FUNCTION    TKSS_ColumnProperty.GetAttributes:TPropertyAttributes;
{+O
---------------------------------------------------------------------------
  Purpose     - This property requires a dialog box.
---------------------------------------------------------------------------}
  BEGIN
    result := INHERITED GetAttributes + [paDialog];
{}END {GetAttributes};




{}FUNCTION    TKSS_ColumnProperty.GetValue:STRING;
{+O
---------------------------------------------------------------------------
  Purpose     - The value to be displayed in the object inspector.
---------------------------------------------------------------------------}
  BEGIN
    result := Format('(%s)',[GetPropType^.Name]);
{}END {GetValue};




{}PROCEDURE   Register;
{+H
---------------------------------------------------------------------------
  Purpose     - Component registering
---------------------------------------------------------------------------}
  BEGIN
    RegisterComponents('Data Access', [TKSS_DataSet,TTextTable]);
    RegisterPropertyEditor(TypeInfo(TObject), TKSS_DataSet, 'ABOUT', TKSS_AboutProperty);
    RegisterComponents('Dialogs', [TKSS_HeaderDialog]);
    RegisterPropertyEditor(TypeInfo(TColumnDefs), TKSS_DataSet, 'Header', TKSS_ColumnProperty);
{}END {Register};



END {KDSetBox}.
