UNIT TextMain;
{+H
---------------------------------------------------------------------------
  File        - TEXTMAIN.PAS
  Purpose     - Demonstrate use of TKSS_CustomDataSet and its descendents
                (specifically TTextTable).
  Remarks     - You will need to compile and install:
                  1. TextPKG.DPK
                  2. KDialogs.DPK
                before using this sample.
---------------------------------------------------------------------------}
INTERFACE
USES
  Windows,  Messages, SysUtils, Classes,  Graphics, Controls, Forms,    Dialogs,
  ExtCtrls, DBCtrls,  Grids,    DBGrids,  Db,       KDataSet, StdCtrls, DBTables,
  KDS_Edit, KSOption;

TYPE
  TTextDataDemoForm = CLASS(TForm)
    Button1   : TButton;
    Button2   : TButton;
    DataSrc1  : TDataSource;
    DBGrid2   : TDBGrid;
    DBNav1    : TDBNavigator;
    dlgHeader : TKSS_HeaderDialog;
    dlgOpen   : TOpenDialog;
    dlgOptions: TKSSOptionsDialog;
    Panel1    : TPanel;
    Panel2    : TPanel;
    TextDSet1 : TTextTable;
    PROCEDURE   BeforeClosingDataSet(DataSet: TDataSet);
    PROCEDURE   FormCreate(Sender: TObject);
    PROCEDURE   OpenBtnClick(Sender: TObject);
    PROCEDURE   RenameClick(Sender: TObject);
    PROCEDURE   TextDSet1GetColumnName(aoSender: TObject; aiColumn,aiRows: Word;
                  VAR asName : STRING;
                      asValue: STRING;
                  VAR aeType : TFieldType);
  PRIVATE
    { Private declarations }
  PUBLIC
    { Public declarations }
  END {CLASS};

VAR
  TextDataDemoForm: TTextDataDemoForm;
              {=================================================}
IMPLEMENTATION
USES
  KSSStore;
{$R *.DFM}



{}PROCEDURE   TTextDataDemoForm.BeforeClosingDataSet(DataSet: TDataSet);
  BEGIN
    TKSS_DataSet(DataSet).Report;
{}END;




{}PROCEDURE TTextDataDemoForm.FormCreate(Sender: TObject);
  BEGIN
    dlgOptions.Items.Add('ftBoolean');
    dlgOptions.Items.Add('ftCurrency');
    dlgOptions.Items.Add('ftDate');
    dlgOptions.Items.Add('ftDateTime');
    dlgOptions.Items.Add('ftFloat');
    dlgOptions.Items.Add('ftInteger');
    dlgOptions.Items.Add('ftSmallInt');
    dlgOptions.Items.Add('ftString');
    dlgOptions.Items.Add('ftTime');
    dlgOptions.Items.Add('ftWord');
{}END {FormCreate};




{}PROCEDURE   TTextDataDemoForm.OpenBtnClick(Sender: TObject);
  CONST
    csCaption : ARRAY[BOOLEAN]OF STRING[5] = ('CLOSE','OPEN');
  BEGIN
    IF Sender IS TButton THEN BEGIN
      IF (Sender AS TButton) = Button1 THEN BEGIN
        IF TextDSet1.FileName = '' THEN BEGIN
          IF dlgOpen.Execute THEN BEGIN
            TextDSet1.FileName := dlgOpen.FileName;
          END {IF};
        END ELSE BEGIN
          TextDSet1.Active := NOT TextDSet1.Active;
          (Sender AS TButton).caption := csCaption[NOT TextDSet1.Active];
          Button2.Enabled := TextDSet1.Active;
          IF NOT TextDSet1.Active THEN BEGIN
            TextDSet1.FileName := '';
          END {IF};
        END {IF};
      END {IF};
    END {IF};
{}END {OpenBtnClick};




{}PROCEDURE   TTextDataDemoForm.RenameClick(Sender: TObject);
  BEGIN
    dlgHeader.Execute;
{}END {RenameClick};




{}PROCEDURE   TTextDataDemoForm.TextDSet1GetColumnName(aoSender: TObject; aiColumn,aiRows: Word;
                  VAR asName : STRING;
                      asValue: STRING;
                  VAR aeType : TFieldType);
  VAR
    li        : INTEGER;
    ls        : STRING;
  BEGIN
    IF TextDSet1.HasHeaderRow THEN BEGIN
      dlgOptions.caption := 'Column '+IntToStr(aiColumn+1)+': '+asName;
      ls := '';
      FOR li := 1 TO Length(asValue) DO BEGIN
        IF asValue[li] = ^I THEN BEGIN
          ls := ls + '; ';
        END ELSE BEGIN
          ls := ls + asValue[li];
        END {IF};
      END {FOR};

      dlgOptions.Comment := 'Sample data for column:'+ls;
      IF dlgOptions.Execute THEN BEGIN
        FOR li := 0 TO dlgOptions.items.Count-1 DO BEGIN
          IF dlgOptions.IsChecked(li) THEN BEGIN
            CASE (li+1) OF
              1 : aeType := ftBoolean;
              2 : aeType := ftCurrency;
              3 : aeType := ftDate;
              4 : aeType := ftDateTime;
              5 : aeType := ftFloat;
              6 : aeType := ftInteger;
              7 : aeType := ftSmallInt;
              8 : aeType := ftString;
              9 : aeType := ftTime;
             10 : aeType := ftWord;
            END {CASE};

            Exit;
          END {IF};
        END {FOR};

        aeType := ftString;
      END {IF};
    END {IF};
{}END {TextDSet1GetColumnName};


END.
